package ballerina.net.jms;

@doc:Description ("Message acknowledgement action implementation for jms connector when using jms client acknowledgement mode")
@doc:Param ("message: message" )
@doc:Param ("deliveryStatus: Specify whether message delivery is SUCCESS or ERROR" )
native function acknowledge (message m, string deliveryStatus);

@doc:Description ("Session rollback action implementation for jms connector when using jms session transaction mode")
@doc:Param ("message: message" )
native function rollback (message m);

@doc:Description ("Session commit action implementation for jms connector when using jms session transaction mode")
@doc:Param ("message: message" )
native function commit (message m);

@doc:Description ("To get the jms message type")
@doc:Param ("message: message" )
native function getMessageType (message m) (string);

@doc:Description ("Native JMS Client Connector")
native connector ClientConnector (string initialContextFactory, string jndiProviderUrl) {

	@doc:Description ("SEND action implementation of the JMS Connector")
	@doc:Param ("connector: Connector" )
	@doc:Param ("connectionFactoryName: Connection Factory Name" )
	@doc:Param ("destinationName: Destination Name" )
	@doc:Param ("destinationType: Destination Type" )
	@doc:Param ("msgType: Message Type" )
	@doc:Param ("message: Message" )
	@doc:Param ("properties: Properties" )
	native action send (ClientConnector jmsClientConnector, string connectionFactoryName, string destinationName, string destinationType, string msgType, message m, map properties) (boolean);

}